#ifndef _WAV_H
#define _WAV_H

#include <stdint.h>

typedef struct {
  char id[4];
  uint32_t length;
  uint16_t compcode;
  uint16_t channels;
  uint32_t samplerate;
  uint32_t bytespersecond;
  uint16_t bytespersample;
  uint16_t bitspersample;
} wav_format;

typedef struct {
  char id[4];
  uint32_t length;
  char type[4];
} wav_header;

typedef struct {
  char id[4];
  uint32_t length;
} wav_data;

/* Main WAV file structure */
typedef struct {
  /* Management structures */
  wav_header OrigHeader;
  wav_format OrigFormat;
  wav_data OrigData;

  /* Content */
  uint32_t numsamples;
  int16_t *samples;
} wav_file;

/* Parses a 16-bit WAV file */
wav_file *readWAV( const char* );

/* Writes a 16-bit WAV file. */
void writeWAV( const wav_file*, const char* );

/* Frees the allocated memory for a WAV file.
 * */
void freeWAV( wav_file* );

#endif
